package com.csc.library.util;

public enum JavaVersion{
	java11(45 , "Java 1.1"),
	java12(46 , "Java 1.2"),
	java13(47 , "Java 1.3"),
	java14(48 , "Java 1.4"),
	java5(49 , "Java 5"),
	java6(50 , "Java 6"),
	java7(51 , "Java 7"),
	java8(52 , "Java 8");
	
	int majorVersion  = 0;
	String javaVersion = "";
	private JavaVersion(int major , String javaVersion){
		this.majorVersion = major;
		this.javaVersion = javaVersion;
	}
	
	public int getMajorVersion(){
		return this.majorVersion;
	}
	
	public String getJavaVersion(){
		return this.javaVersion;
	}
	
	public static JavaVersion getJavaVersion(String javaVersion){
		for(JavaVersion j : JavaVersion.values()){
			if(javaVersion.equalsIgnoreCase(j.getJavaVersion())){
				return j;
			}
		}
		return null;
	}
	
	public static JavaVersion getJavaVersion(int major){
		for(JavaVersion j : JavaVersion.values()){
			if(major == j.getMajorVersion()){
				return j;
			}
		}
		return null;
	}
}