package com.csc.library.util.scanner;

import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.List;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;
import java.util.regex.Pattern;

import com.csc.library.util.FileJarFilter;
import com.csc.library.util.JarFileUtil;

public class FindClassInJarFile {
	private String pathApp = "";
	
	public FindClassInJarFile(String path){
		this.setPath(path);
	}
	
	public void setPath(String path){
		this.pathApp = path;
	}
	
	public void scan(String className){
		List<File> jarList = this.getListFileJar();
		JarFile jf = null;
		Pattern pJar = Pattern.compile(".*?"+className+".class\\z" , Pattern.CASE_INSENSITIVE);
		StringBuffer sb = new StringBuffer();
		int count = 0;
		for(File jFile : jarList){
			try{
				jf = new JarFile(jFile);
				Enumeration<JarEntry> enu = jf.entries();
				while(enu.hasMoreElements()){
					JarEntry je = enu.nextElement();
					if(pJar.matcher(je.getName()).find()){
						sb.append(count+"  :  "+jFile.getPath());
						break;
					}
				}
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		if(sb.length() > 0){
			System.out.println("List Jar File is found class ["+className+"] in Path ["+this.pathApp+"]\r\n"+sb.toString());
		}else{
			System.out.println("Cannot find class ["+className+"] in Path ["+this.pathApp+"]");
		}
	}

	private List<File> getListFileJar(){
		File f = new File(this.pathApp);
		if( f.isDirectory() ){
			return Arrays.asList(f.listFiles(new FileJarFilter()));
		}else if(JarFileUtil.isJarFile(f)){
			return Arrays.asList(f);
		}else{
			return new ArrayList<File>();
		}
	}
	
	public static void main(String[] args) {
		String strPath = "D:\\EnterprisePT\\Programmer\\myHRAppServer\\webapps\\Essilor\\hrAppWeb.war\\WEB-INF\\lib";
		String className = "com.csc.library.databean.ttime_current1";
		FindClassInJarFile fc = new FindClassInJarFile(strPath);
		fc.scan(className);
	}
}
