package com.csc.library.util.scanner;


import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.jar.JarEntry;
import java.util.jar.JarFile;

import com.csc.library.util.ClassFileUtil;
import com.csc.library.util.JarFileUtil;
import com.csc.library.util.JavaVersion;

public class FindMajorVersionNumber{
	private String pathApp = "";
	private JavaVersion jbossVersion = JavaVersion.java5;

     public FindMajorVersionNumber(String path){
    	 this.pathApp = path;
     }
     
     public FindMajorVersionNumber(String path , JavaVersion jversion){
    	 this.pathApp = path;
    	 this.jbossVersion = jversion;
     }
     
     public FindMajorVersionNumber(String path , int version){
    	 this.pathApp = path;
    	 JavaVersion tmp = JavaVersion.getJavaVersion(version);
    	 if( tmp != null ){
    		 this.jbossVersion = tmp;
    	 }
     }

     public void scan() throws Exception{
    	 System.out.println("Start...............");
         List<File> listJarFile = this.getListJarFile(this.pathApp);
         StringBuffer sb = new StringBuffer();
         for(int i = 0; i<listJarFile.size(); i++){
        	 JarFile jarFile = new JarFile(listJarFile.get(i));

             Enumeration allEntries = jarFile.entries();
             while (allEntries.hasMoreElements()) {
                 JarEntry entry = (JarEntry) allEntries.nextElement();
            	 InputStream in = jarFile.getInputStream(entry);
            	 if(ClassFileUtil.isClassFile(entry.getName())){
            		 JavaVersion j = ClassFileUtil.getJavaVersion(in);
            		 if( this.jbossVersion.getMajorVersion() < j.getMajorVersion() ){
            			 sb.append(jarFile.getName()+" : "+entry.getName() +" : "+ j.getJavaVersion()+"\n");
            		 }
            	 }
            	 in.close();
             }
         }
         System.out.println(sb.toString());
         System.out.println("Define Jboss version is : "+this.jbossVersion.getJavaVersion());
         System.out.println("end...............");
     }
     
     private List<File> getListJarFile(String pathBase){
    	 ArrayList<File> arr = new ArrayList<File>();
    	 File path = new File(pathBase);
    	 if(path.isDirectory()){
    		 File[] files = path.listFiles();
    		 for(int i = 0;i < files.length; i ++){
    			 String pathFile = files[i].getPath();
    			 if(JarFileUtil.isJarFile(pathFile)){
    				 arr.add(files[i]);
    				// System.out.println(pathFile);
    			 }
    		 }
    	 }else{
    		 arr.add(path);
    	 }
    	 return arr;
     }
     
     public static void main(String[] args) throws Exception {
    	 String strPath = "D:\\EnterprisePT\\Programmer\\myHRAppServer\\webapps\\Essilor\\hrAppWeb.war\\WEB-INF\\lib";
    	 //FindMajorVersionNumber findMajor = new FindMajorVersionNumber(strPath);
    	 FindMajorVersionNumber findMajor = new FindMajorVersionNumber(strPath , JavaVersion.java6);
    	 findMajor.scan();
     }
     
}